(define-module (mastostart-gnu packages mastostart)
  #:use-module (gnu)
  #:use-module (guix packages)
  #:use-module (gnu packages php)
  #:use-module (guix download)
  #:use-module (guix git-download)
  #:use-module (guix packages)
  #:use-module (guix build utils)
  #:use-module (guix build-system trivial))

(define %mastostart-commit "23b5e21a87b4a46fb8d2e7fc9f9e9d2f2385ce93")

(define-public mastostart
  (let ((version "0.0.0")
        (revision "0")
        (commit %mastostart-commit))
    (package
      (name "mastostart")
      (version (git-version version revision commit))
      (source (origin
                (method git-fetch)
                (uri (git-reference
                      (url "https://git.lattuga.net/pongrebio/MastodonStartpage")
                      (commit commit)))
                (file-name (git-file-name name version))
                (sha256
                 (base32
                  "1crxjabj3a6yvlaqxirjv5gf24m0rlhqjdmnz0km6ldnljy9i3zv"))))
      (build-system trivial-build-system)
      (arguments
       `(#:modules ((guix build utils))
         #:builder (begin
                     (use-modules (guix build utils))
                     (let ((source (assoc-ref %build-inputs "source"))
                           (out (assoc-ref %outputs "out")))
                       (copy-recursively source ".")
                       ;; Attiva quando lo script per configurare è completo
                       ;; (invoke "./configure"
                       ;;         "goodoldpaul@autistici.org"
                       ;;         "goodoldpaul@autistici.org"
                       ;;         "1G")
                       (mkdir-p out)
                       (copy-recursively "." out)
                       #t))))
      (inputs
       `(("php" ,php)))
      (home-page "")
      (synopsis "")
      (description "")
      (license #f))))
